SystemOrganization addCategory: #'GBT-DSL_BuddyWallet'!

Object subclass: #BuddyWallet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_BuddyWallet'!

!BuddyWallet class methodsFor: 'example' stamp: 'hk 12/14/2016 10:37'!
buddyWallet: userName  
	^self new buddyWallet: userName ! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 12/14/2016 10:36'!
exampleClear
	GbtStore clearStore. 
	GbtSVO initialize. ! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 12/14/2016 13:33'!
exampleData
	self new storeAccounts ! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 12/17/2016 16:20'!
exampleRun
	(self new buddyWallet: '') open
! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 12/17/2016 16:20'!
exampleRunLogin
	self new login open
! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 12/17/2016 14:25'!
account
	^GbtThing newStruct: 'Account' define: {
		{ #summary . 'account template' }.
		{ #IBAN . #val: . '' }.
		{ #amount . #no: . 0 }.
		{ #currency .  #val: . 'EUR' } .
		{ #owner .  #thing: . self contact}.
		{ #dispo . #no: . 0 }.
		{ #transferLimit . #no: . 1000 }.
	}! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 12/14/2016 13:40'!
account01
	"self new account01 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1234 5678 9876 5432' ;	
		amount: 1000;
		firstName: #Helmut ;
		lastName: #Schmidt;
		cityName: #Hamburg;
		yourself.

! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 12/14/2016 13:41'!
account02
	"self new account02 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 9876 1234' ;	
		amount: 500;
		firstName: #Helmut ;
		lastName: #Kohl;
		cityName: #Oggersheim;
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 12/14/2016 13:41'!
account03
	"self new account03 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 0054 1234' ;	
		amount: 1500;
		firstName: #Helmut ;
		lastName: #Lange;
		cityName: #Hamburg;
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 12/14/2016 13:42'!
account04
	"self new account04 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 0045 9876' ;	
		amount: -500;
		firstName: #Helmut ;
		lastName: #Schmitz;
		cityName: #Köln;
		yourself ! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 12/14/2016 10:21'!
accountContext: userName  
	^GbtPlainAC newStruct: 'AccountContext'  for: userName define: {
		{#displayAs: . 'Account'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts}.
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 12/14/2016 13:30'!
accounts: userName  
	^GbtBigListAC newStruct: 'Accounts'  for: userName define: {
		{#displayAs: . 'Accounts'} .
		{#noPolicyPrefix: . 'Acc'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self account} .
		{#loadPolicy: . #autoload } .
		{#display: . #(IBAN firstName lastName cityName)} .
		{#subcontext: . self accountContext: userName}}! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 12/13/2016 17:47'!
address
	^GbtThing newStruct: 'Address' define: { 
		{ #street . #val: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityName . #val: . ''}.	
		{ #cityCode . #val: . ''}} ! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 12/18/2016 15:39'!
buddyWallet: userName  
	"(self new buddyWallet: '' ) open" 

	^GbtPlainAC newStruct: 'BuddyWallet'  for: userName define: {
		{#aspect:on: . self accounts: userName . #customer  } .
		{#aspect:on: . self transfers: userName . #wallet  } .
		{#uiSpec:icon: . #GbtMainUI . #walletBig} .
		{#extent: . (800 @ 600)}.
	}! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 12/13/2016 17:47'!
contact
	^GbtThing newStruct: 'Contact' define: {
		{ #firstName . #val: . ''}.
		{ #lastName . #val: . ''}.
		{ #eMail . #val: . '' }.					
		{ #phone .  #val: . '' } .
	} full: { 
		{ #address .  #thing: . self address}.
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 12/18/2016 12:24'!
doitBehavior: behName  
	^GbtBehavior newStruct: behName arguments: #() define: #(
		READSLOT #(source vSourceIBAN)							"assign the accounts to the roles"
		READSLOT #(target vTargetIBAN)							"get both IBANs"
		ASKROLE #(Accounts vSourceIBAN transferSource) 	"get  accounts for source"
		ASKROLE #(Accounts vTargetIBAN transferSink) 		"and target into the roles"
		TRANSFORM #(transferSource SourceDecl sourceVar)	"get a.o. the source amount"
		TRANSFORM #(transferSink SinkDecl sinkVar)			"and the sink amount"
		COMPOSE #(TransferDecl sourceVar	sinkVar)			"make the core tx thing with the pool thing,too"						
		CHECK #transferCheck 										"check contraints"
		READSLOT #(newSourceAmount newSourceA) 				"read the final"
		READSLOT #(newSinkAmount newSinkA) 					"account values"
		WRITESLOT #(newSourceA transferSource amount) 		"write them"
		WRITESLOT #(newSinkA transferSink amount) 			"into the accounts"
		COMMIT #void 												"commit the tx"
		ASSIGNTODAY #(contextVO date)
		ASSIGNVAL #(ZU14QF contextVO tan)
	)! !

!BuddyWallet methodsFor: 'role things & decls' stamp: 'hk 12/16/2016 14:53'!
installDeclaratives
	self sinkDecl; sourceDecl; transferDecl! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 12/14/2016 10:28'!
installUsers
	EFA installUsers! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 12/18/2016 15:38'!
login
	self installUsers.
	^ GbtLoginAC newStruct: 'BuddyWalletLogin' for: '' define:
			{{#uiSpec:icon: . nil . #walletBig}.
			{#displayAs: . #BuddyWallet}.
			{#appClass:selector: . #BuddyWallet . #buddyWallet:}.
			{#legalText: . 'GloConn International © 2016'}}! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 12/16/2016 13:58'!
nextBizID
	"noPolicy for the test data"
	^(GbtStore contextNoPolicyOf: #accounts) prefix: #Acc; nextID! !

!BuddyWallet methodsFor: 'role things & decls' stamp: 'hk 12/16/2016 14:54'!
sinkDecl
	^GbtDeclarative newStruct: 'SinkDecl' define: {
		{ #oldSinkAmount . #tag: .#amount } }! !

!BuddyWallet methodsFor: 'role things & decls' stamp: 'hk 12/16/2016 14:54'!
sourceDecl
	^GbtDeclarative newStruct: 'SourceDecl' define: {
		{ #oldSourceAmount . #tag: . #amount }.
		{ #dispo } .
		{ #transferLimit} .
	}! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 12/14/2016 15:08'!
storeAccounts
	self account01 store.
	self account02 store.
	self account03 store.
	self account04 store! !

!BuddyWallet methodsFor: 'role things & decls' stamp: 'hk 12/16/2016 15:30'!
transfer
	"at the core of the calculation"
	^GbtThing newStruct: 'Transfer' define: {
		{ #newSourceAmount . #calc: . '#oldSourceAmount - #transferAmount' }.
		{ #newSinkAmount . #calc: . '#oldSinkAmount + #transferAmount' } .
		{ #limitConstraint . #constraint: . '#transferAmount asNumber < #transferLimit asNumber' } .
		{ #dispoConstraint . #constraint: . '#oldSourceAmount asNumber - #transferAmount asNumber + #dispo asNumber >= 0' } .
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 12/18/2016 15:39'!
transferContext: userName  
	self installDeclaratives .
	^GbtPlainAC newStruct: 'TransferContext'  for: userName define: {
		{#displayAs: . 'TransferOrder'  } .
		{#uiSpec:icon: . #GbtItemUI . #wallet}.
		{#roles: . #(transferSource transferSink) }.
		{#chooseFor:use:from: . #source . #IBAN . self accounts: userName }.
		{#chooseFor:use:from: . #target . #IBAN . self accounts: userName }.
		{#poolThings: . self transfer}.
		{#menu: . #doit}.
		{#behavior: . self doitBehavior: #doit}.
	}! !

!BuddyWallet methodsFor: 'role things & decls' stamp: 'hk 12/16/2016 15:04'!
transferDecl
	"takes as source i) the transformed source, ii) the transfer order and iii) the transfer thing "
	^GbtDeclarative newStruct: 'TransferDecl' define: {
		{ #oldSourceAmount }.
		{ #oldSinkAmount }.
		{ #dispo } .
		{ #transferLimit} .
		{ #transferAmount} .
		{ #newSourceAmount }.
		{ #newSinkAmount } .
		{ #limitConstraint } .
		{ #dispoConstraint } .
	}! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 12/17/2016 14:26'!
transferOrder
	^GbtThing newStruct: 'TransferOrder' define: {
		{ #summary . 'transfer order template' }.
		{ #transferAmount . #no: . 0 }.
		{ #currency .  #val: . 'EUR' } .
	} full: { 
		{ #source .  #val: . '' }.
		{ #target .  #val: . '' }.
		{ #date .  #date: . ''}.
		{ #tan .  #val: . ''}.
	}! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 12/18/2016 15:39'!
transfers: userName  
	^GbtBigListAC newStruct: 'Transfers'  for: userName define: {
		{#displayAs: . 'Transfers'} .
		{#noPolicyPrefix: . 'MTF'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #wallet} .
		{#templates: . self transferOrder} .
		{#loadPolicy: . #autoload } .
		{#display: . #(#(transferAmount amount) currency #(source von) #(target an))} .
		{#subcontext: . self transferContext: userName}.
	}! !
